/*
 * ison.c -- handles doing /ison and stuff
 * Written by Jeremy Nelson, 1995
 * see the COPYRIGHT file or do /help ircII copyright
 */

struct ison_queue {
	struct ison_queue *next;
	void (*function) _((char *, char *));
	char *user_request_list;
	char *server_returned_list;
}

struct ison_queue *ison_list = NULL;

void do_ison (char *nicklist, void (*function) _((char *, char *)))
{
	send_to_server("ISON %s", nicklist);
	if (ison_queue == NULL)
	{
		ison_queue = (struct ison_queue *)new_malloc(sizeof(struct ison_queue));
		list = ison_queue;
	}
	else 
	{
		list = ison_queue;
		while (list->next)
			list = list->next;
		list->next = (struct ison_queue *)new_malloc(sizeof(struct ison_queue));
		list = list->next;
	}

	list->next = NULL;
	list->user_requested_list = NULL;
	list->server_returned_list = NULL;
	list->function = function;
	malloc_strcpy(&(list->user_requested_list), nicklist);
}

void parse_ison_303 (char *from, char **ArgList)
{
